#ifndef _DRV_TAPI_VXWORKS_H
#define _DRV_TAPI_VXWORKS_H
/******************************************************************************

                              Copyright (c) 2009
                            Lantiq Deutschland GmbH
                     Am Campeon 3; 85579 Neubiberg, Germany

  For licensing information, see the file 'LICENSE' in the root folder of
  this software module.

******************************************************************************/

/**
   This file contains the declarations of the vxworks specific driver functions.
*/

/* ============================= */
/* Global Includes               */
/* ============================= */

/* ============================= */
/* Macros & Definitions          */
/* ============================= */

#ifndef _IOC_NR
   #define _IOC_NR(cmd) (IOCBASECMD(cmd) & 0xff)
#endif /* _IOC_NR */

#ifndef _IOC_SIZE
   #define _IOC_SIZE(cmd) IOCPARM_LEN(cmd)
#endif /* _IOC_SIZE */

#ifndef _IOC_TYPE
   #define _IOC_TYPE(cmd) IOCGROUP(cmd)
#endif /* _IOC_TYPE */

#ifndef _IOC_DIR
   #define _IOC_DIR(cmd)   (cmd)
   #define _IOC_WRITE      IOC_IN
   #define _IOC_READ       IOC_OUT
#endif /* _IOC_TYPE */

/* ============================= */
/* Global Structures             */
/* ============================= */

#ifdef TAPI_HAVE_TIMERS
   #ifndef SYS_DRV_TIMERLIB_VXWORKS_H
      typedef timer_t   Timer_ID;
      typedef VOID (*TIMER_ENTRY)(Timer_ID timerid, UINT32 arg);
   #endif /* SYS_DRV_TIMERLIB_VXWORKS_H */
#endif /* TAPI_HAVE_TIMERS */

/* ============================= */
/* Global function declaration   */
/* ============================= */

#ifdef TAPI_HAVE_TIMERS
   #ifndef SYS_DRV_TIMERLIB_VXWORKS_H
      extern Timer_ID InstallTimer(TIMER_ENTRY pTimerEntry,
                             IFX_uint32_t nTime, IFX_int32_t nArgument, IFX_boolean_t bEnableTimer);
      extern BOOL StartTimer(Timer_ID Timer);
      extern BOOL StopTimer(Timer_ID Timer);
      extern BOOL DeleteTimer(Timer_ID Timer);
      extern BOOL SetTimeTimer(Timer_ID Timer,
                              IFX_uint32_t nTime, IFX_boolean_t bPeriodically, IFX_boolean_t bRestart);

      extern Timer_ID          TAPI_Create_Timer     (TIMER_ENTRY pTimerEntry, IFX_ulong_t nArgument);
      extern IFX_boolean_t     TAPI_SetTime_Timer    (Timer_ID Timer, IFX_uint32_t nTime, IFX_boolean_t bPeriodically, IFX_boolean_t bRestart);
      extern IFX_boolean_t     TAPI_Delete_Timer     (Timer_ID Timer);
      extern IFX_boolean_t     TAPI_Stop_Timer       (Timer_ID Timer);
   #endif /* SYS_DRV_TIMERLIB_VXWORKS_H */
#endif /* TAPI_HAVE_TIMERS */

#endif /* _DRV_TAPI_VXWORKS_H */
